;; ---------------------------------------------------------------------
; @file    usb_sub.s
; @brief   t\tgUSBi^C~O̐䂪Kvȏj
; @author  ߂ ߂遗€˂Ƌl(http://yaginet.seesaa.net/)
; @date    2011-08-24
; 
; ----------------------------------------------------------------------
    .include "p30f3012.inc"

    .global __T1Interrupt
    .global _usb_snd_full
    .global _usb_rcv_full
    .global _usb_snd_low
    .global _usb_rcv_low
    .global _usb_wr_full
    .global _usb_rd_full
    .global _usb_wr_low
    .global _usb_rd_low

    .text

;--------------------------------------------------
; ݃[`
;-------------------------------------------------- 
__T1Interrupt:
    push.s
    bclr    IFS0,#0x3
    inc     _usb_time
    pop.s
    retfie

;--------------------------------------------------
; MitXs[hj
;   w0  :   Mf[^obt@
;-------------------------------------------------- 
_usb_snd_full:
    push.s

    ; o͂̐ݒio͂ցj
    clr     TRISC               ; D+, D-o
    mov     #0x02CE, w3         ; PORTC
    dec     [w0++], w2          ; Mf[^

    ; o
    repeat  w2
    mov     [w0++], [w3]

    ; o͂̐ݒi͂ցj
    mov     #0x4000, w2         ; D+:H, D-:L    SE0
    mov     w2, LATC            ;               J
    setm    TRISC               ; D+, D-  J

    pop.s
    return

;--------------------------------------------------
; MitXs[hj
;   w0  :   Mf[^̖ڈ
;-------------------------------------------------- 
_usb_rcv_full:
    push.s

    ; o͂̐ݒ
    mov     #0x02CE, w3         ; PORTC

    ; IDLEłȂȂiD+:L, D-:HƂȂj܂ő҂
    mov     #0x2000, w2
_usb_rcv_full_wait_0:
    cp      w2, [w3]
    bra     nz, _usb_rcv_full_wait_0

    ; 
    mov     _usb_rcv_ptr, w2    ; Mf[^obt@
    repeat  w0
    mov     [w3], [w2++]

    ; i[f[^
    mov     w0, _usb_rcv_len

    ; IDLEƂȂiD+:H, D-:LƂȂj܂ő҂
    mov     #0x4000, w2
_usb_rcv_full_wait_1:
    cp      w2, [w3]
    bra     nz, _usb_rcv_full_wait_1

    pop.s
    return

;--------------------------------------------------
; USB ReaditXs[hj
;   w0  :   Mf[^obt@
;   w1  :   Mf[^̖ڈ
;-------------------------------------------------- 
_usb_rd_full:
    push.s

    ; o͂̐ݒio͂ցj
    clr     TRISC               ; D+, D-o
    mov     #0x02CE, w3         ; PORTC
    dec     [w0++], w2          ; Mf[^

    ; o
    repeat  w2
    mov     [w0++], [w3]        ; zXg   => foCXig[Nj

    ; o͂̐ݒi͂ցj
    mov     #0x4000, w2         ; D+:H, D-:L    SE0
    mov     w2, LATC            ;               J
    setm    TRISC               ; D+, D-  J

    ; IDLEłȂȂiD+:H, D-:LłȂȂj܂ő҂
_usb_rd_full_wait_0:
    cp      w2, [w3]
    bra     z, _usb_rd_full_wait_0

    ; 
    mov     _usb_rcv_ptr, w2    ; Mf[^obt@
    repeat  w1
    mov     [w3], [w2++]        ; foCX => zXgif[^j

    ; i[f[^
    mov     w1, _usb_rcv_len

    ; PID̊mF
    mov     #0x4000, w2
    mov     _usb_rcv_ptr, w1    ; KA鎟̃f[^ɂĊmF
_usb_rd_full_chk:
    cp      w2, [w1++]
    bra     z, _usb_rd_full_chk
    cp      w2, [w1++]
    bra     z, _usb_rd_full_chk
    and     w2, [w1], w1        ; bit140(K) => DATA0/1   => ACKM
    bra     nz, _usb_rd_full_nak; bit141(J) => NAK/STALL => i[f[^0

    ; IDLEƂȂiD+:H, D-:LƂȂj܂ő҂
_usb_rd_full_wait_1:
    cp      w2, [w3]
    bra     nz, _usb_rd_full_wait_1

    ; o͂̐ݒio͂ցj
    clr     TRISC               ; D+, D-o
    dec     [w0++], w2          ; Mf[^

    ; o
    repeat  w2
    mov     [w0++], [w3]        ; zXg   => foCXiACKj

    ; o͂̐ݒi͂ցj
    mov     #0x4000, w2         ; D+:H, D-:L    SE0
    mov     w2, LATC            ;               J
    setm    TRISC               ; D+, D-  J

    pop.s
    return

    ; i[f[^0ŏI
_usb_rd_full_nak:
    cp      w2, [w3]
    bra     nz, _usb_rd_full_nak
    clr     _usb_rcv_len
    pop.s
    return

;--------------------------------------------------
; USB WriteitXs[hj
;   w0  :   Mf[^obt@
;   w1  :   Mf[^̖ڈ
;-------------------------------------------------- 
_usb_wr_full:
    push.s

    ; o͂̐ݒio͂ցj
    clr     TRISC               ; D+, D-o
    mov     #0x02CE, w3         ; PORTC
    dec     [w0++], w2          ; Mf[^

    ; o
    repeat  w2
    mov     [w0++], [w3]        ; zXg   => foCXig[Nj

    mov     #0x4000, w2         ; D+:H, D-:L    SE0
    mov     w2, [w3]            ;               J
    dec     [w0++], w2          ; Mf[^  J

    repeat  w2
    mov     [w0++], [w3]        ; zXg   => foCXif[^j

    ; o͂̐ݒi͂ցj
    mov     #0x4000, w2         ; D+:H, D-:L    SE0
    mov     w2, LATC            ;               J
    setm    TRISC               ; D+, D-  J

    ; IDLEłȂȂiD+:H, D-:LłȂȂj܂ő҂
_usb_wr_full_wait_0:
    cp      w2, [w3]
    bra     z, _usb_wr_full_wait_0

    ; 
    mov     _usb_rcv_ptr, w2    ; Mf[^obt@
    repeat  w1
    mov     [w3], [w2++]        ; foCX => zXgiACKj

    ; i[f[^
    mov     w1, _usb_rcv_len

    ; IDLEƂȂiD+:H, D-:LƂȂj܂ő҂
    mov     #0x4000, w2
_usb_wr_full_wait_1:
    cp      w2, [w3]
    bra     nz, _usb_wr_full_wait_1

    pop.s
    return

;--------------------------------------------------
; Mi[Xs[hj
;   w0  :   Mf[^obt@
;-------------------------------------------------- 
_usb_snd_low:
    push.s

    ; o͂̐ݒio͂ցj
    clr     TRISC               ; D+, D-o
    mov     #0x02CE, w3         ; PORTC
    mov     [w0++], w2          ; Mf[^

    ; o
_usb_snd_low_set:
    mov     [w0++], [w3]
    repeat  #0x2
    nop
    dec     w2, w2
    bra     nz, _usb_snd_low_set

    ; o͂̐ݒi͂ցj
    mov     #0x2000, w2         ; D+:L, D-:H
    mov     w2, LATC
    setm    TRISC               ; D+, D-

    pop.s
    return

;--------------------------------------------------
; Mi[Xs[hj
;   w0  :   Mf[^̖ڈigpȂj
;-------------------------------------------------- 
_usb_rcv_low:
    push.s

    ; o͂̐ݒ
    mov     #0x02CE, w3         ; PORTC
    mov     _usb_rcv_ptr, w2    ; Mf[^obt@
    clr     w1

    ; IDLEłȂȂiD+:L, D-:HłȂȂj܂ő҂
    mov     #0x2000, w0
_usb_rcv_low_wait_0:
    cp      w0, [w3]
    bra     z, _usb_rcv_low_wait_0

    ; 
_usb_rcv_low_get:
    mov     [w3], [w2]
    cp0     [w2++]
    bra     z, _usb_rcv_low_exit
    inc     w1, w1
    nop
    nop
    goto    _usb_rcv_low_get

    ; i[f[^
_usb_rcv_low_exit:
    mov     w1, _usb_rcv_len
    
    ; IDLEƂȂiD+:L, D-:HƂȂj܂ő҂
_usb_rcv_low_wait_1:
    cp      w0, [w3]
    bra     nz, _usb_rcv_low_wait_1

    pop.s
    return

;--------------------------------------------------
; USB Readi[Xs[hj
;   w0  :   Mf[^obt@
;   w1  :   Mf[^̖ڈigpȂj
;-------------------------------------------------- 
_usb_rd_low:
    push.s
    inc     [w0], w2            ; 2xڂ̑Mp
    sl      w2, #0x1, w2
    mov     _usb_rcv_ptr, w1    ; PIDmFp
    add     #0x10, w1
    mov     #0x2000, w3
    call    _usb_snd_low        ; zXg   => foCXig[Nj
    call    _usb_rcv_low        ; foCX => zXgif[^j
    and     w3, [w1], w3        ; bit130(K) => DATA0/1   => ACKM
    bra     nz, _usb_rd_low_nak ; bit131(J) => NAK/STALL => i[f[^0
    add     w0, w2, w0
    call    _usb_snd_low        ; zXg   => foCXiACKj
    pop.s
    return
_usb_rd_low_nak:
    clr     _usb_rcv_len     
    pop.s
    return

;--------------------------------------------------
; USB Writei[Xs[hj
;   w0  :   Mf[^obt@
;   w1  :   Mf[^̖ڈigpȂj
;-------------------------------------------------- 
_usb_wr_low:
    push.s
    inc     [w0], w2
    sl      w2, #0x1, w2
    call    _usb_snd_low    ; zXg   => foCXig[Nj
    add     w0, w2, w0
    call    _usb_snd_low    ; zXg   => foCXif[^j
    call    _usb_rcv_low    ; foCX => zXgiACKj
    pop.s
    return

